//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "RsAlias.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRsAlias *)
{
        new TRsAlias(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRsAlias::TRsAlias(TComponent* Owner)
        : TComponent(Owner)
{
    FAliasParameters = new TStringList;

}
//---------------------------------------------------------------------------
namespace Rsalias
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TRsAlias)};
                 RegisterComponents("Rapid - Misc", classes, 0);
        }
}
//---------------------------------------------------------------------------


void __fastcall TRsAlias::Execute()
{
        //TODO: Add your source code here
        if (FUseBDEAPI)
          InstallBDEAPI();
        else
          InstallVCL();

}

void __fastcall TRsAlias::InstallBDEAPI()
{
        //TODO: Add your source code here
      try
      {
         String Option = BuildOptions();

         CheckBDE(DbiInit(NULL));
         // This will fail if the alias is not there so do not check the return
         // value for DbiDeleteAlias.. if not deleted we will get a non-unique context
         // error when creating the alias
         if (FDeleteIfExists)
           DbiDeleteAlias(NULL,FAliasName.c_str());

         bool Saveit = false;
         if (FPersistent)
            Saveit = true;

         if (FDriverType=="STANDARD")
            CheckBDE(DbiAddAlias(NULL,FAliasName.c_str(),NULL,Option.c_str(), Saveit));
         else
           CheckBDE(DbiAddAlias(NULL,FAliasName.c_str(),FDriverType.c_str(),Option.c_str(), Saveit));

         DbiExit();

     }
     // catch the exception and de-init the bde and throw the exception
     catch (Exception &e)
     {
        DbiExit();
        if (FOnError)
          FOnError(this,e.Message);
        else
         throw Exception(e.Message);

     }
}

void __fastcall TRsAlias::CheckBDE(DBIResult value)
{
    //TODO: Add your source code here
    if (value !=DBIERR_NONE)
    {
      char error[DBIMAXMSGLEN+1];
      DbiGetErrorString(value,error);

      throw Exception(error);
    }


}
void __fastcall TRsAlias::InstallVCL()
{
        //TODO: Add your source code here
        try
        {
           if (FDeleteIfExists)
             Session->DeleteAlias(FAliasName);

           Session->AddAlias(FAliasName,FDriverType,FAliasParameters);
           if (FPersistent)
             Session->SaveConfigFile();
        }
        catch (Exception &e)
        {
           if (FOnError)
              OnError(this,e.Message);
           else
              throw Exception (e.Message);
        }



}

__fastcall TRsAlias::~TRsAlias()
{
        //TODO: Add your source code here
        delete FAliasParameters;
        FAliasParameters = NULL;

}

String __fastcall TRsAlias::BuildOptions()
{
        //TODO: Add your source code here
        char *ptemp;
        String ret = "";

        for (int c=0;c<FAliasParameters->Count;c++)
        {
            ptemp = FAliasParameters->Strings[c].c_str();

            while(*ptemp)
            {
              if (*ptemp=='=')
              {
                 ret+=": ";
              }
              else
                ret+=*ptemp;

              ptemp++;
            }

        }
        return ret;


}

void __fastcall TRsAlias::SetAliasParameters(TStringList* value)
{

    FAliasParameters->Assign(value);
    

}

String __fastcall TRsAlias::GetDriverType()
{

   return FDriverType;

}
void __fastcall TRsAlias::SetDriverType(String value)
{
   FDriverType = value;

}

void __fastcall TRsAlias::GetDriverTypes(TStringList* List)
{

   Session->GetDriverNames(List);



}


